
/*
 * @copyright
 *
 *  Copyright 2015 Neo Natura
 *
 *  This file is part of the Share Library.
 *  (https://github.com/neonatura/share)
 *        
 *  The Share Library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version. 
 *
 *  The Share Library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with The Share Library.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  @endcopyright
 */  

#include "sharedaemon.h"

static const char reg_kmap[] = {
'\0', '\0', '\0', '\0', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', 0x0A, 0x1b, 0x08, '\t', ' ', '-', '=', '[', ']', '\\', '#', ';', '\'', ' ', ',', '.', '/', ' ', ' ', ' '
};

static const char shift_kmap[] = {
'\0', '\0', '\0', '\0', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', 0x0A, 0x1b, 0x08, '\t', ' ', '_', '+', '{', '}', '|', '~', ':', '"', ' ', '<', '>', '?', ' ', ' ', ' '
};

char card_kmap_convert(char *inbuf)
{
  char code;

  code = 0;
  if (inbuf[2] > 0 && inbuf[2] < 60) {
    if (inbuf[0] == 2) {
      /* shifted */
      code = shift_kmap[inbuf[2]];
    } else if (inbuf[0] == 0) {
      /* regular */
      code = reg_kmap[inbuf[2]];
    }
  }

  return (code);
}

